/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.15).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package br.com.brasilprev.controllers;

import br.com.brasilprev.models.Customer;
import br.com.brasilprev.presenters.CustomerPresenter;
import br.com.brasilprev.presenters.CustomersPresenter;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;


@Api(value = "customers", description = "Customers Controller", tags = {"Cadastro de clientes."})
@RequestMapping(value = "/")
public interface CustomersController {

    @ApiOperation(value = "Listar clientes", nickname = "customersGet", notes = "Listar todos os clientes cadastrados.", response = CustomersPresenter.class, authorizations = {
        @Authorization(value = "JWT")
    }, tags={ "Cadastro de clientes.", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ok", response = CustomersPresenter.class),
        @ApiResponse(code = 400, message = "Bad Request", response = Error.class),
        @ApiResponse(code = 401, message = "Unauthorized", response = Error.class),
        @ApiResponse(code = 403, message = "Forbidden", response = Error.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = Error.class) })
    @RequestMapping(value = "/customers",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<CustomersPresenter> customersGet();


    @ApiOperation(value = "Apagar cliente", nickname = "customersIdDelete", notes = "Apagar um cliente por id.", response = CustomerPresenter.class, authorizations = {
        @Authorization(value = "JWT")
    }, tags={ "Cadastro de clientes.", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ok"),
        @ApiResponse(code = 400, message = "Bad Request", response = Error.class),
        @ApiResponse(code = 401, message = "Unauthorized", response = Error.class),
        @ApiResponse(code = 403, message = "Forbidden", response = Error.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = Error.class) })
    @RequestMapping(value = "/customers/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    @ResponseStatus(HttpStatus.OK)
    void customersIdDelete(@ApiParam(value = "Número da conta do cliente",required=true) @PathVariable("id") Integer id);


    @ApiOperation(value = "Listar cliente", nickname = "customersIdGet", notes = "Listar um cliente por id.", response = CustomerPresenter.class, authorizations = {
        @Authorization(value = "JWT")
    }, tags={ "Cadastro de clientes.", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ok", response = CustomerPresenter.class),
        @ApiResponse(code = 400, message = "Bad Request", response = Error.class),
        @ApiResponse(code = 401, message = "Unauthorized", response = Error.class),
        @ApiResponse(code = 403, message = "Forbidden", response = Error.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = Error.class) })
    @RequestMapping(value = "/customers/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<CustomerPresenter> customersIdGet(@ApiParam(value = "Número da conta do cliente",required=true) @PathVariable("id") Integer id);


    @ApiOperation(value = "Incluir cliente", nickname = "customersPost", notes = "Incluir um cliente na base de dados.", response = CustomerPresenter.class, authorizations = {
        @Authorization(value = "JWT")
    }, tags={ "Cadastro de clientes.", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ok", response = CustomerPresenter.class),
        @ApiResponse(code = 400, message = "Bad Request", response = Error.class),
        @ApiResponse(code = 401, message = "Unauthorized", response = Error.class),
        @ApiResponse(code = 403, message = "Forbidden", response = Error.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = Error.class) })
    @RequestMapping(value = "/customers",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<CustomerPresenter> customersPost(@ApiParam(value = "" ,required=true )  @Valid @RequestBody Customer body);


    @ApiOperation(value = "Modificar cliente", nickname = "customersPut", notes = "Modificar um cliente na base de dados.", response = CustomerPresenter.class, authorizations = {
        @Authorization(value = "JWT")
    }, tags={ "Cadastro de clientes.", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ok", response = CustomerPresenter.class),
        @ApiResponse(code = 400, message = "Bad Request", response = Error.class),
        @ApiResponse(code = 401, message = "Unauthorized", response = Error.class),
        @ApiResponse(code = 403, message = "Forbidden", response = Error.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = Error.class) })
    @RequestMapping(value = "/customers",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.PUT)
    ResponseEntity<CustomerPresenter> customersPut(@ApiParam(value = "" ,required=true )  @Valid @RequestBody Customer body);

}
